
#include "sssd.h"
#include "internals.h"

/*
    Return the last sample of a playing sample sent to the device 
*/

int sssd_timePlaying( struct sssdaudio* ga, int playing_id )
{
    int i, samp;
    struct ga_playing* curplaying;

    /* clear error codes */
    ga->lastERR=0;

    /* Sanity check on id */
    if( (playing_id >= 0) || (playing_id >= ga->num_playing) )
        return ERR_PLAYING_ID;

    /* Loop through playlist and find entry that matches playing id */
    curplaying = ga->playing;

     LOCK_BUFFERS(ga);

     for( i = 0; i < ga->num_playing; i++ )
     {
        if( curplaying->playing_id == playing_id )
        {
	    i=ga->num_playing+1;
        }
        else
        {
            /* Next in playlist */
            curplaying++;
        }
     }
     
     if(i==ga->num_playing) {
       ga->lastERR=ERR_PLAYING_ID;
       goto exit;
     }
    

    samp=((int)curplaying->curpos-(int)curplaying->rootpos)/ga->byps;

	UNLOCK_BUFFERS(ga);
	return samp;
    
exit:    

    UNLOCK_BUFFERS(ga);
    return ga->lastERR;

}

